from __future__ import annotations
from dataclasses import dataclass, field
from kiota_abstractions.serialization import AdditionalDataHolder, Parsable, ParseNode, SerializationWriter
from typing import Any, Callable, Dict, List, Optional, TYPE_CHECKING, Union

if TYPE_CHECKING:
    from ..models.stream_video_library.replication_regions import ReplicationRegions

@dataclass
class VideolibraryPostRequestBody(AdditionalDataHolder, Parsable):
    # Stores additional data not described in the OpenAPI description found when deserializing. Can be used for serialization as well.
    additional_data: Dict[str, Any] = field(default_factory=dict)

    # The name of the Video Library.
    name: Optional[str] = None
    # The geo-replication regions of the underlying storage zone
    replication_regions: Optional[List[ReplicationRegions]] = None
    
    @staticmethod
    def create_from_discriminator_value(parse_node: ParseNode) -> VideolibraryPostRequestBody:
        """
        Creates a new instance of the appropriate class based on discriminator value
        param parse_node: The parse node to use to read the discriminator value and create the object
        Returns: VideolibraryPostRequestBody
        """
        if not parse_node:
            raise TypeError("parse_node cannot be null.")
        return VideolibraryPostRequestBody()
    
    def get_field_deserializers(self,) -> Dict[str, Callable[[ParseNode], None]]:
        """
        The deserialization information for the current model
        Returns: Dict[str, Callable[[ParseNode], None]]
        """
        from ..models.stream_video_library.replication_regions import ReplicationRegions

        from ..models.stream_video_library.replication_regions import ReplicationRegions

        fields: Dict[str, Callable[[Any], None]] = {
            "Name": lambda n : setattr(self, 'name', n.get_str_value()),
            "ReplicationRegions": lambda n : setattr(self, 'replication_regions', n.get_collection_of_enum_values(ReplicationRegions)),
        }
        return fields
    
    def serialize(self,writer: SerializationWriter) -> None:
        """
        Serializes information the current object
        param writer: Serialization writer to use to serialize this model
        Returns: None
        """
        if not writer:
            raise TypeError("writer cannot be null.")
        writer.write_str_value("Name", self.name)
        writer.write_collection_of_enum_values("ReplicationRegions", self.replication_regions)
        writer.write_additional_data_value(self.additional_data)
    

